<?php
namespace Incoviba\Repository\Venta;

use Incoviba\Common\Ideal;
use Incoviba\Common\Define;
use Incoviba\Common\Implement;
use Incoviba\Model;

class TipoEstadoVenta extends Ideal\Repository
{
    public function __construct(Define\Connection $connection)
    {
        parent::__construct($connection);
        $this->setTable('tipo_estado_venta');
    }

    public function create(?array $data = null): Model\Venta\TipoEstadoVenta
    {
        $map = (new Implement\Repository\MapperParser(['descripcion']))
            ->register('activa', new Implement\Repository\Mapper\Boolean('activa'));
        return $this->parseData(new Model\Venta\TipoEstadoVenta(), $data, $map);
    }
    public function save(Define\Model $model): Model\Venta\TipoEstadoVenta
    {
        $model->id = $this->saveNew(
            ['descripcion', 'activa'],
            [$model->descripcion, $model->activa ? 1 : 0]
        );
        return $model;
    }
    public function edit(Define\Model $model, array $new_data): Model\Venta\TipoEstadoVenta
    {
        return $this->update($model, ['descripcion', 'activa'], $new_data);
    }

    /**
     * @param string $descripcion
     * @return Model\Venta\TipoEstadoVenta
     * @throws Implement\Exception\EmptyResult
     */
    public function fetchByDescripcion(string $descripcion): Model\Venta\TipoEstadoVenta
    {
        $query = "SELECT * FROM `{$this->getTable()}` WHERE `descripcion` = ?";
        return $this->fetchOne($query, [$descripcion]);
    }
}
